"use strict";const Service=require("egg").Service,table_agent="agent",table_user="user",redis_agent="redis_agent",redis_agent_child="redis_agent_child",allMember="allMember",allAgent="allAgent";class Agent extends Service{async listAll(){const{ctx:e,app:t}=this,a=await t.db.select(table_agent,{orders:[["created_at","asc"]]});if(a.length>0){if(!await t.redis.exists(redis_agent)){let e=[];for(let t in a){let n=a[t];e.push(n.account,JSON.stringify(n))}await t.redis.hmset(redis_agent,e)}}return a}async findByAccount(e){const{ctx:t,app:a}=this;if(!e)return null;const n=await a.redis.hget(redis_agent,e);if(n){let e=JSON.parse(n);return e.coin||(e.coin=0),e}const r=await a.db.get(table_agent,{account:e});return r&&await a.redis.hset(redis_agent,e,JSON.stringify(r)),r}async findChildrenByAgent(e){const{ctx:t,app:a}=this;let n=e;n||(n="root");let r=await a.redis.smembers(redis_agent_child+n);if(r&&r.length>0){const e=[];r=await a.redis.hmget(redis_agent,r);for(let t in r){let a=r[t];if(a){let t=JSON.parse(a);t.coin||(t.coin=0),e.push(t)}}return e}let i={where:{parent:e}};e||(i.where={Literal:"parent is null"});const s=await a.db.select(table_agent,i);if(s.length>0){let e=[],t=[];for(let a in s){let n=s[a];e.push(n.account),t.push(n.account,JSON.stringify(n))}await a.redis.hmset(redis_agent,t),await a.redis.sadd(redis_agent_child+n,e)}return s}async getRootAgentList(){return this.findChildrenByAgent(null)}async getValidRootAgentList(){const{ctx:e,app:t}=this;let a={where:{Literal:" parent is null ORDER BY created_at"}};return await t.db.select(table_agent,a)}async getAllAgentByKeyWorld(e,t){const{ctx:a,app:n}=this;let r=`name like '%${e}%' or from_base64(account) like '%${e}%' or phone like '%${e}'`;switch(t){case"name":r=`name like '%${e}%'`;break;case"account":r=`from_base64(account) like '%${e}%'`;break;case"phone":r=`phone = '${e}'`}return await n.db.select(table_agent,{where:{Literal:r}})}async getAgentsByOption(e){const{ctx:t,app:a}=this;return await a.db.select(table_agent,e)}async getAgentNum(e){const{ctx:t,app:a}=this;return await a.db.count(table_agent,e)}async washAgents(e){const{ctx:t,app:a}=this;let n=[],r=[];for(let t in e){let a=e[t],i={account:a.account,coin:a.coin,washDay:a.washDay};n.push(i),r.push(a.account)}if(n.length<=0)return;try{if((await a.db.insert(table_agent,n,{Literal:" on duplicate key update coin = coin + values(coin), validCoin = validCoin + values(coin), washDay = values(washDay) "})).affectedRows<1)return!1}catch(n){return a.logger.error("Wash Agent Error: ",n),await t.service.schedule.cacheErrorData("agent","wash",e),!1}const i=await a.db.select(table_agent,{where:{account:r}});if(i.length>0){let e=[];for(let t in i){let a=i[t];e.push(a.account,JSON.stringify(a))}await a.redis.hmset(redis_agent,e)}return!0}async washAgentParents(e){const{ctx:t,app:a}=this;let n=[],r=[];for(let t in e){let a=e[t];if(!a)continue;let i={account:a.account,coin:a.coin};n.push(i),r.push(a.account)}if(r.length<=0)return;try{if((await a.db.insert(table_agent,n,{Literal:" on duplicate key update validCoin = validCoin + values(coin) "})).affectedRows<1)return!1}catch(n){return a.logger.error("Wash Parent Error: ",n),await t.service.schedule.cacheErrorData("parent","wash",e),!1}const i=await a.db.select(table_agent,{where:{account:r}});if(i.length>0){let e=[];for(let t in i){let a=i[t];e.push(a.account,JSON.stringify(a))}await a.redis.hmset(redis_agent,e)}return!0}async create(e){const{ctx:t,app:a}=this;if(e.coin&&(e.validCoin=e.coin),1!=(await a.db.insert(table_agent,e)).affectedRows)return!1;t.service.agentRelation.create(e.account,e.parent);const n=await a.db.get(table_agent,{account:e.account});await a.redis.hset(redis_agent,e.account,JSON.stringify(n)),await a.redis.sismember(allAgent,e.account)||await a.redis.sadd(allAgent,e.account);let r=e.parent;return r||(r="root"),await a.redis.exists(redis_agent_child+r)&&await a.redis.sadd(redis_agent_child+r,e.account),!0}async update(e,t){const{ctx:a,app:n}=this;if(1!=(await n.db.update(table_agent,t,{where:{account:e}})).affectedRows)return null;const r=await n.db.get(table_agent,{account:e});return await n.redis.hset(redis_agent,e,JSON.stringify(r)),r}async updateArr(e,t){const{ctx:a,app:n}=this;if((await n.db.update(table_agent,t,{where:{account:e}})).affectedRows<1)return!1;const r=await n.db.select(table_agent,{where:{account:e}});if(r.length>0){let e=[];for(let t in r){let a=r[t];e.push(a.account,JSON.stringify(a))}await n.redis.hmset(redis_agent,e)}return!0}async updateWithOption(e,t){const{ctx:a,app:n}=this;let r=[];for(let t in e)r.push(e[t].account);if(r.length<=0)return!0;if((await n.db.insert(table_agent,e,t)).affectedRows<1)return!1;const i=await n.db.select(table_agent,{where:{account:r}});if(i.length>0){let e=[];for(let t in i){let a=i[t];e.push(a.account,JSON.stringify(a))}await n.redis.hmset(redis_agent,e)}return!0}async transBaseInfo(e){const{ctx:t,app:a}=this;let n={account:e.account,name:e.name,state:e.state,coin:t.helper.floor(e.coin).toString(),drawRate:e.drawRate.toString(),washRate:e.washRate.toString(),stake:e.stake.toString(),washType:e.washType,agentType:e.agentType,limitIdArr:e.limitIdList?JSON.parse(e.limitIdList):[],innerGameType:e.innerGameType,inStake:e.inStake?e.inStake:0};return e.parent&&(n.parent=t.helper.decode64(e.parent)),n}async modifyAgentPassword(e,t,a){const{ctx:n,app:r}=this;if(1!=(await r.db.update(table_agent,{pwd:a,pwdChanged:1},{where:{account:e}})).affectedRows)return!1;const i=await r.redis.hget(redis_agent,e);if(i){let t=JSON.parse(i);t.pwd=a,t.pwdChanged=1,await r.redis.hset(redis_agent,e,JSON.stringify(t))}return!0}async checkAgentType(e,t){const{ctx:a,app:n}=this,r=await a.service.agentRelation.findParents(e);let i={where:{account:r,agentType:2}};if(r&&r.length>0){if((await a.service.agent.getAgentsByOption(i)).length>0)return!0}if(!t)return!1;const s=await a.service.agentRelation.findChildren(e);if(s.length>0){if(i={where:{account:s,agentType:2}},(await a.service.agent.getAgentsByOption(i)).length>0)return!0}return s.push(e),i={where:{parent:s,agentType:2}},(await a.service.member.getMembersByOption(i)).length>0}async checkInstake(e,t,a){const{ctx:n,app:r}=this;if(2==t.inStake&&!a)return 1;const i=await n.service.agentRelation.findParents(e);if(!i||0==i.length)return 0;let s={where:{account:i,inStake:2}},c=await n.service.agent.getAgentsByOption(s);if(a&&2==t.inStake&&c.push({account:e}),!c||0==c.length)return 0;let l=await n.service.config.getConfigByKey("recharge");if(l&&l.value){let e=JSON.parse(l.value).agentArr;c=c.filter(t=>e.indexOf(t.account)<0)}return c.length>0?1:0}async checkOpenTask(e){const{ctx:t,app:a}=this;let n=await this.findByAccount(e);if(1==await t.service.agent.checkInstake(e,n,!0))return 1;const r=await t.service.agentRelation.findParents(e);r.push(e);let i={where:{account:r,openTask:2}};return(await this.getAgentsByOption(i)).length>0?1:0}async balanceAgents(e){const{ctx:t,app:a}=this;let n=[],r=[],i=[];t.logger.info("balanceAgents: ",e);for(let t in e){let a={account:t,winNum:e[t].winNum};n.push(t),r.push(a),i.push(`'${t}'`)}if(n.length<=0)return!0;i.join(",");try{if((await a.db.insert(table_agent,r,{Literal:" on duplicate key update validCoin = validCoin + values(winNum) "})).affectedRows<1)return!1}catch(n){return a.logger.error("Balance Agent Error: ",n),await t.service.schedule.cacheErrorData("agent","balance",e),!1}const s=await a.db.select(table_agent,{where:{account:n}});if(s.length>0){let e=[];for(let t in s){let a=s[t];e.push(a.account,JSON.stringify(a))}await a.redis.hmset(redis_agent,e)}return!0}async getCanUserAccount(e){const{ctx:t,app:a}=this;let n=6;1==e&&(n=8);let r=Math.pow(10,n-1),i=0,s="";for(;s.length<n;)s+="9";i=parseInt(s,0);let c=Math.ceil(Math.random()*(i-r))+r,l=allMember;2===e&&(l=allAgent);let o=t.helper.encode64(c);return await a.redis.sismember(l,o)?this.getCanUserAccount(e):c.toString()}async linkChangeRate(e,t){const{ctx:a,app:n}=this;let r=!t.washType||e.washType===t.washType,i={agent:[],member:[]};if(e.drawRate==t.drawRate&&e.washRate==t.washRate&&e.openTask==t.openTask&&e.stake<=t.stake&&r)return i;let s={},c={};e.washRate>t.washRate?s.washRate=t.washRate:e.washRate<t.washRate&&(c.washRate=t.washRate),e.drawRate>t.drawRate?s.drawRate=t.drawRate:e.drawRate<t.drawRate&&(c.drawRate=t.drawRate),e.stake>t.stake&&(s.stake=t.stake),e.openTask!=t.openTask&&2==t.openTask&&(s.openTask=t.openTask);const l=await a.service.agentRelation.findChildren(e.account);let o=[e.account];o=o.concat(l);let h=await a.service.member.getMembersByOption({where:{parent:o}}),w=[];for(let e of h)w.push(e.account);if(s.washRate||0==s.washRate){if(l.length>0){let e={where:{account:l,Literal:`washRate > ${s.washRate}`}};await n.db.update(table_agent,{washRate:s.washRate},e)}if(w.length>0){let e={where:{account:w,Literal:`washRate > ${s.washRate}`}};await a.service.member.updateWithOption(w,{washRate:s.washRate},e)}}if(s.drawRate||0==s.drawRate){if(l.length>0){let e={where:{account:l,Literal:`drawRate > ${s.drawRate}`}};await n.db.update(table_agent,{drawRate:s.drawRate},e)}if(w.length>0){let e={where:{account:w,Literal:`drawRate > ${s.drawRate}`}};await a.service.member.updateWithOption(w,{drawRate:s.drawRate},e)}}if((s.stake||0==s.stake)&&l.length>0){let e={where:{account:l,Literal:`stake > ${s.stake}`}};await this.getAgentsByOption(e);await n.db.update(table_agent,{stake:s.stake},e)}if(!r){if(o.length>0){i.agent=await n.db.select(table_agent,{where:{account:o,Literal:`washType <> ${t.washType}`}});let e={where:{account:o,Literal:`washType <> ${t.washType}`}};await n.db.update(table_agent,{washType:t.washType},e)}if(w.length>0){i.member=await a.service.member.getMembersByOption({where:{account:w,Literal:`washType <> ${t.washType}`}});let e={where:{account:w,Literal:`washType <> ${t.washType}`}};await a.service.member.updateWithOption(w,{washType:t.washType},e)}}if(s.openTask){if(l.length>0){let e={where:{account:l,Literal:"openTask = 1"}};await n.db.update(table_agent,{openTask:2},e)}if(w.length>0){let e={where:{account:w,Literal:"openTask = 1"}};await a.service.member.updateWithOption(w,{openTask:2},e)}}if(c.washRate||0==c.washRate){if(l.length>0){let e={where:{agentType:2,account:l,Literal:`washRate <> ${c.washRate}`}};await n.db.update(table_agent,{washRate:c.washRate},e)}if(w.length>0){let e={where:{account:w,agentType:2,Literal:`washRate <> ${c.washRate}`}};await a.service.member.updateWithOption(w,{washRate:c.washRate},e)}}if(c.drawRate||0==c.drawRate){if(l.length>0){let e={where:{agentType:2,account:l,Literal:`drawRate <> ${c.drawRate}`}};await n.db.update(table_agent,{drawRate:c.drawRate},e)}if(w.length>0){let e={where:{account:w,agentType:2,Literal:`drawRate <> ${c.drawRate}`}};await a.service.member.updateWithOption(w,{drawRate:c.drawRate},e)}}if(0===l.length)return i;const g=await n.db.select(table_agent,{where:{account:l}});if(g.length>0){let e=[];for(let t in g){let a=g[t];e.push(a.account,JSON.stringify(a))}await n.redis.hmset(redis_agent,e)}return i}async linkChangeInnerGameTypeByAgent(e,t){const{ctx:a,app:n}=this;let r={agent:[],member:[]};if(!t.innerGameType||e.innerGameType===t.innerGameType||3===t.innerGameType)return r;const i=await a.service.agentRelation.findChildren(e.account);let s=[];i.length>0&&(s=await a.service.agent.getAgentsByOption({where:{account:i}}));let c=[e.account];c=c.concat(i);let l=await a.service.member.getMembersByOption({where:{parent:c}}),o=[];for(let e of s)e.innerGameType!==t.innerGameType&&(o.push(e.account),r.agent.push(e));let h=[];for(let e of l)e.innerGameType!==t.innerGameType&&(h.push(e.account),r.member.push(e));if(r.agent.length>0){let e={where:{account:o,Literal:`innerGameType <> ${t.innerGameType}`}};await n.db.update(table_agent,{innerGameType:t.innerGameType},e)}if(r.member.length>0){let e={where:{account:h,Literal:`innerGameType <> ${t.innerGameType}`}};await a.service.member.updateWithOption(h,{innerGameType:t.innerGameType},e)}if(o.length>0){let e=await a.service.agent.getAgentsByOption({where:{account:o}}),t=[];for(let a in e){let n=e[a];t.push(n.account,JSON.stringify(n))}await n.redis.hmset(redis_agent,t)}return r}async linkChangeWashTypeByAgent(e,t){const{ctx:a,app:n}=this;let r={agent:[],member:[]};if(!t.washType||e.washType===t.washType||1===t.washType)return r;const i=await a.service.agentRelation.findChildren(e.account);let s=[];i.length>0&&(s=await a.service.agent.getAgentsByOption({where:{account:i}}));let c=[e.account];c=c.concat(i);let l=await a.service.member.getMembersByOption({where:{parent:c}}),o=[];for(let e of s)e.washType!==t.washType&&(o.push(e.account),r.agent.push(e));let h=[];for(let e of l)e.washType!==t.washType&&(h.push(e.account),r.member.push(e));if(r.agent.length>0){let e={where:{account:o,Literal:`washType <> ${t.washType}`}};await n.db.update(table_agent,{washType:t.washType},e)}if(r.member.length>0){let e={where:{account:h,Literal:`washType <> ${t.washType}`}};await a.service.member.updateWithOption(h,{washType:t.washType},e)}if(o.length>0){let e=await a.service.agent.getAgentsByOption({where:{account:o}}),t=[];for(let a in e){let n=e[a];t.push(n.account,JSON.stringify(n))}await n.redis.hmset(redis_agent,t)}return r}async linkChangeWithDrawalLock(e,t){const{ctx:a,app:n}=this;let r={agent:!1,member:!1},i=[],s=[],c=e.withdrawalLock!=t.withdrawalLock&&2==t.withdrawalLock,l=e.rechargeLock!=t.rechargeLock&&2==t.rechargeLock,o=c||l,h={};if(c&&(h.withdrawalLock=2),l&&(h.rechargeLock=2),o){const t=await a.service.agentRelation.findChildren(e.account);let n=[e.account].concat(t),r=[],o="withdrawalLock = 1";l&&(o="rechargeLock = 1",c&&(o="(rechargeLock = 1 or withdrawalLock = 1)")),t.length>0&&(r=await this.getAgentsByOption({where:{account:t,Literal:o}}));let h=await a.service.member.getMembersByOption({where:{parent:n,Literal:o}});for(let e of r)i.push(e.account);for(let e of h)s.push(e.account)}if(i.length>0){let e={where:{account:i}};await n.db.update(table_agent,h,e);let t=await a.service.agent.getAgentsByOption({where:{account:i}}),s=[];for(let e in t){let a=t[e];s.push(a.account,JSON.stringify(a))}await n.redis.hmset(redis_agent,s),r.agent=!0}if(s.length>0){let e={where:{account:s}};await a.service.member.updateWithOption(s,h,e),r.member=!0}let w=[];for(let e in s)w.push(a.helper.decode64(s[e]));return r.memberArr=w,r}async resetErrLoginNum(){const{ctx:e,app:t}=this,a=await t.db.select(table_agent,{where:{Literal:"errLoginNum <> 0"}});if(0==a.length)return!0;let n=[];for(let e of a)n.push(e.account);if((await t.db.update(table_agent,{errLoginNum:0},{where:{account:n}})).affectedRows<1)return!1;const r=await t.db.select(table_agent,{where:{account:n}});if(r.length>0){let e=[];for(let t in r){let a=r[t];e.push(a.account,JSON.stringify(a))}await t.redis.hmset(redis_agent,e)}return!0}async updateWithLiteral(e,t){const{ctx:a,app:n}=this;if((await n.db.insert(table_agent,e,{Literal:t})).affectedRows<1)return!1;let r=[];for(const t in e)r.push(e[t].account);const i=await n.db.select(table_agent,{where:{account:r}});if(i.length>0){let e=[];for(let t in i){let a=i[t];e.push(a.account,JSON.stringify(a))}await n.redis.hmset(redis_agent,e)}return!0}async getPromoUserAccount(e){const{ctx:t,app:a}=this;let n=Math.pow(10,5),r=0,i=e.substring(0,2),s="";for(;s.length<6;)s+="9";r=parseInt(s,0);let c=Math.ceil(Math.random()*(r-n))+n;c=i+c;let l=allMember,o=t.helper.encode64(c);return await a.redis.sismember(l,o)?this.getCanUserAccount(e):(c.toString(),c)}async checkUserInfo(e,t,a,n){const{ctx:r,app:i}=this;let s=!1;if(1==e.withdrawalLock||1==e.rechargeLock){let n=await this.checkAllowForbidden(e.account,e,t,a);4==n&&(s=!0),3==n&&1==e.withdrawalLock&&(s=!0),2==n&&1==e.rechargeLock&&(s=!0)}return e.moneyType&&(0!=n.moneyType&&n.moneyType!=e.moneyType&&(s=!0),0==e.moneyType&&(s=!0)),3==e.innerGameType&&1==t&&(r.logger.error("checkUserInfo",`更新用户${e.account}-${e.name}福利类型异常，userInfo.innerGameType：${e.innerGameType}`),s=!0),s}async checkAllowForbidden(e,t,a,n){const{ctx:r,app:i}=this;let s=1,c=2,l=3,o=4;if(!e)return 0;let h=await r.service.config.getConfigByKey("recharge"),w=[];if(h&&h.value){let e=JSON.parse(h.value);w=e.agentArr}if(2==t.inStake&&t.parent)return w.indexOf(e)>=0?s:o;let g=e;1==a&&(g=t.parent);let p=await r.service.agentRelation.findParents(g);if((n||1==a)&&p.push(g),!p||0==p.length)return 0;let u={where:{account:p,inStake:2}},d=await r.service.agent.getAgentsByOption(u),f=!1;d&&d.length>0&&(f=(d=d.filter(e=>w.indexOf(e.account)<0)).length>0),u={where:{account:p,withdrawalLock:2}};let y=(d=await r.service.agent.getAgentsByOption(u))&&d.length>0;u={where:{account:p,rechargeLock:2}};let m=(d=await r.service.agent.getAgentsByOption(u))&&d.length>0;return f||y&&m?o:y?l:m?c:s}}module.exports=Agent;